<!-- $Id: wms_notes.asp,v 1.5 2002/06/11 13:35:27 Administrator Exp $ -->

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<TITLE> Internet Mail Client Control Webmail Sample - Notes</TITLE>
<LINK REL = "stylesheet" TYPE = "text/css" HREF = "wms_style.css"> 
</HEAD>

<BODY CLASS="wms">

<!-- Outer layout table -->
<TABLE CLASS="wms_layout">

<!-- Web mail banner -->
<TR><TD>
<CENTER><IMG SRC="wms_banner.jpg" WIDTH="600" HEIGHT="48" BORDER=0 ALT="Webmail sample"></CENTER>
<IMG SRC="wms-spacer.jpg" WIDTH="600" HEIGHT="8" BORDER=0 ALT="spacer">
</TD></TR>

<TR><TD>

<TABLE CLASS="wms_toolbar">
	<TR>
	<TD><A HREF="http://www.codestone.co.uk/software/docs/csmail/samples/asp-wms/wms.zip">Download the webmail sample</A></TD>
	</TR>
</TABLE>


<H1 CLASS="wms">Introduction</H1>

<P CLASS="wms">
This sample uses a webmail system to demonstrate how to use the Internet Mail Client Control Library on your ISS/ASP site. Using this sample you can:

<UL>
	<LI CLASS="wms"> Login to a POP3 server and read the messages in a maildrop.
	<LI CLASS="wms"> Display the messages and their attachments. 
	<LI CLASS="wms"> Reply to a message.
	<LI CLASS="wms"> Delete messages on the POP3 server.
	<LI CLASS="wms"> Compose a new message.
	<LI CLASS="wms"> Connect to an SMTP server and send a message.

</UL>
</P>

<P CLASS="wms">
The Webmail sample may provide a useful starting point for your own application but it's not a complete solution - in particular you should consider the following points - 

<UL>
	<LI CLASS="wms"> Error checking code has been largely omited from the sample so as not to obscure the code.
	<LI CLASS="wms"> There are security issues around any ISS application. The sample does not address security issues, for example the sample sends inappropriate information through POST requests - this is not something you should do on a non-secured server.
	<LI CLASS="wms"> The sample caches messages and attachments to improve performance. There is a trade-of between bandwidth and disk space here - caching the message means that if the user reads a message more than once the system doesn't have to download it again from the POP server but it does use disk space on the ISS. You need to consider your local conditions and decide what, if any, caching strategy you need.
	<LI CLASS="wms"> The sample assumes that all the attachments in a message will have unique names. This is not necessarily the case. 
	<LI CLASS="wms"> The sample also assumes that UIDLs will be unique across POP3 servers, this is a bad assumption, if your application accesses more than one POP3 server you will need to address this.

</UL>

</P>



<IMG SRC="wms-spacer.jpg" WIDTH="600" HEIGHT="8" BORDER=0 ALT="spacer">

<H1 CLASS="wms">Files in the webmail sample</H1>

<P CLASS="wms">
Figure 1 shows the relationship between the asp files in this distribution.
</P>

<IMG SRC="wms_files.jpg" WIDTH="594" HEIGHT="362" BORDER=0 ALT="" USEMAP="#wms_files">

<MAP NAME="wms_files">
<AREA SHAPE="rect" COORDS="190,11,384,77" HREF="#wms_login" ALT="User Login Form">
<AREA SHAPE="rect" COORDS="191,111,384,180" HREF="#wms_inbox" ALT="Inbox">
<AREA SHAPE="rect" COORDS="3,143,178,224" HREF="#wms_sendmail" ALT="Send mail through SMTP server">
<AREA SHAPE="rect" COORDS="120,259,305,328" HREF="#wms_compose" ALT="Compose Email">
<AREA SHAPE="rect" COORDS="401,53,582,125" HREF="#wms_logout" ALT="Logout">
<AREA SHAPE="rect" COORDS="403,149,571,213" HREF="#wms_deletemail" ALT="Delete mail from POP3 server">
<AREA SHAPE="rect" COORDS="312,261,505,331" HREF="#wms_readmail" ALT="Read message">
</MAP>


<H2 CLASS="wms"><A NAME="wms_login">wms_login.asp</A></H2>
<P CLASS="wms">
Presents the user with a simple HTML form to provide the details needed by the webmail sample.
</P>

<P CLASS="wms_todo">
<B>Note</B>
In a production system you'd be more likely to store the user's POP3 and SMTP details locally and have a site specific login. 

<H2 CLASS="wms"><A NAME="wms_inbox">wms_inbox.asp</A></H2>
<P CLASS="wms">
Connects to the POP3 server, gets the message headers and presents the user with a list of messages in the maildrop. 
This page uses POP3TOP rather than RetrieveMessages so that only the message headers are retrieved.
</P>

<P CLASS="wms_todo">
<B>Note</B>
The sample does not sort the messages in the inbox - they are presented in the same order as the POP3 server returns them, in a production system your users may well expect to be able to sort the messages by Sender, Subject or Date.
</P>

<H2 CLASS="wms"><A NAME="wms_readmail">wms_readmail.asp</A></H2>
<P CLASS="wms">
Displays the message text and a list of attachments.
</P>

<P CLASS="wms_todo">
<B>Note</B>
Only the text/plain sections of the emails are displayed. You will need to decide which textual parts of the email are displayed. Showing text/html sections is tempting but you need to consider if a sender could post malicious HTML and compromise the security of the system. Advanced application may also wish to take into consideration the semantics of the various multipart/* content types.
</P>


<H2 CLASS="wms"><A NAME="wms_deletemail">wms_deletemail.asp</A></H2>
<P CLASS="wms">
Deletes a message from the maildrop, redirects the user back to wms_inbox.asp.
</P>

<P CLASS="wms_todo">
This sample does not present the user with an opportunity to confirm or cancel the deletion.
</P>


<H2 CLASS="wms"><A NAME="wms_compose">wms_compose.asp</A></H2>
<P CLASS="wms">
Allows the user to compose an email.
<P CLASS="wms_todo">
<B>Note</B>
It would be cool to allow the user to attach files to the email.
</P>
</P>

<H2 CLASS="wms"><A NAME="wms_sendmail">wms_sendmail.asp</A></H2>
<P CLASS="wms">
Sends a message to the SMTP server, redirects the user back to wms_inbox.asp.
</P>

<P CLASS="wms_todo">
This sample does not present the user with an opportunity to confirm or cancel the sending of the email.
</P>


<H2 CLASS="wms"><A NAME="wms_logout">wms_logout.asp</A></H2>
<P CLASS="wms">
Clears the IIS session and redirects the user back to wms_login.asp.
</P>

<IMG SRC="wms-spacer.jpg" WIDTH="600" HEIGHT="8" BORDER=0 ALT="spacer">

<!-- Outer layout table -->
</TD></TR></TABLE>

</BODY>
</HTML>
